#include "cantus.h"

void download_main();
//void evmboardinit();
void mass_storage_main();

void TRIPinit()
{
	*R_PAF0 = 0xFFFF;  // GPIO 
	*R_PAF1 = 0x0FFF;  // UART7, GPIO
	*R_PAF2 = 0xFFFF;  // GPIO
	*R_PAF3 = 0xFFFF;  // GPIO
	*R_PAF4 = 0xFFFF;  // GPIO
	*R_PAF5 = 0xFFFF;  // GPIO
	*R_PAF6 = 0x030C;  // PIO6.1 -> USB-Communication mode, PIO6.4 -> USB Ctrl
	*R_P6oDIR |= (1<<4); // PIO6.4 output mode
}

volatile U8 mode_time=0;

void timerisr_100ms()
{
	mode_time++;
}

int main()
{

	char ch, modekey;
	
	KEY key;
	TRIPinit();
	InitInterrupt();
	UartConfig(7,115200,DATABITS_8,STOPBITS_1,UART_PARNONE);
	debugstring("================================================\r\n");
	debugprintf(" BootLoader. System Clock(%dMhz)\r\n",GetAHBclock()/1000000);
	debugstring("================================================\r\n");
	void (*AppFunc)();
	//USB On, not USB ctrl
	*R_P6oDIR = (1<<4);//PIO6.4 output
	*R_P6oLOW = (1<<4);//PIO6.4 high , off
	
	//USB Download mode
	*R_P6iDIR = (1<<1);//PIO6.1 input
	
	dcache_invalidate_way();
	
	setinterrupt(INTNUM_TIMER0,timerisr_100ms);
	settimer(0,100);
	
	while(mode_time != 10)
	{
		
		modekey = *R_P6iLEV ;
			
		if(0 == (modekey&0x02))
		{
			stoptimer(0);
			*R_P6oHIGH = (1<<4);//PIO6.4 high , on
			delayms(10);
			debugstring("USB-Communication mode\r\n");
			download_main();
		}
	}
	stoptimer(0);
	U8 norid[2];
	norflash_readid(norid);
	int nor_size = norflash_get_size();
	debugprintf("Nor-Flash Size : 0x%x\r\n",nor_size);
	U32 app_loaded_offset;
	if(nor_size == 0x20000) // 128Kbyte
		app_loaded_offset = 32*1024;// 2nd sector (0x8000)
	else
		app_loaded_offset = 64*1024;// 1st sector (0x10000)
		AppFunc = (void (*)())(*(U32*)(app_loaded_offset));// 2nd sector
	if( ((U32)AppFunc <app_loaded_offset) || ((U32)AppFunc > nor_size))
	{
		debugprintf("AppFunc(0x%x) is invalid\r\n",AppFunc);
	}
	else
	{
		debugstring("Run Application\r\n");
		AppFunc();
	}
	return 0;
}
